<%@ LANGUAGE="VBSCRIPT" %>
<% PageStrings = "330, 311, 332, 333, 335, 339, 354, 403, 404, 405, 406, 407, 408, 440, 1483, 1590, 1690, 1691"
strThisBackPage = "orders" %>
<!--#include file="includes/config.asp"-->
<!--#include file="includes/functions.asp"-->
<!--#include file="includes/back_security.asp"-->
<%
'===============================================
' CactuShop ASP Shopping Cart
' 1999-2007 Cactusoft International FZ-LLC
' www.cactusoft.com
'===============================================
' All rights reserved.							
' Use of this code is covered by the terms and	
' conditions in the license agreement. No		
' unauthorized duplication or distribution is	
' permitted. Cactusoft's copyright notices must	
' remain in the ASP sections of the code.		
'===============================================

'-----------------------------------------------
'CUSTOMERS LIST									
'Shows customers, allows the store owner to find
'a customer, list all their orders and give them
'a discount which will be applied to future		
'purchases from the shop.
'List types:
'	Affiliates only (strAffiliates=y)
'	By customer group (CG_ID=id)
'	Approved affiliates only (strApprove=y)				
'	By 
'-----------------------------------------------
Const PAGE_SIZE = 35
Const MAX_PAGES = 14


Function GetLikeStatement(aryFields, strKeyword)
	strKeywordSQL = strUnicode & "'%" & SQLSafe(strKeyword) & "%'"
	
	For i = 0 to ubound(aryFields)
		If i = 0 then
			GetLikeStatement = aryFields(i) & " LIKE " & strKeywordSQL
		Else
			GetLikeStatement = GetLikeStatement & " OR " & aryFields(i) & " LIKE " & strKeywordSQL
		End If
	Next
End Function

'Filter fields
strSearchText = Request.Querystring("strSearchText")
CG_ID = NumSafe(Request.QueryString("CG_ID"))
blnApprovedOnly = (Request.Querystring("strApprove") = "y")
blnAffiliatesOnly = (Request.Querystring("strAffiliates") = "y")
blnMailingListOnly = (Request.Querystring("strMailingList") = "y")
numStartRecord = NumSafe(request.QueryString("numStartRecord"))

If blnApprovedOnly then strSelectedFilter = strSelectedFilter + "&strApprove=y"
If blnAffiliatesOnly then strSelectedFilter = strSelectedFilter + "&strAffiliates=y"
If blnMailingListOnly then strSelectedFilter = strSelectedFilter + "&strMailingList=y"

If numStartRecord = 0 then numStartRecord = 1

'Useful application variables
strAppAffiliateCommissionOnlyOnPaid = GetAppVar("affiliatecommissiononlyonpaid")
numDueDays = GetAppVar("affiliatecommissionduedays")
datOldOrder = DateAdd("d", -numDueDays, NowOffset)

'Set filter 
strWhereClause = "1=1"

If CG_ID > 0 then
	strWhereClause = strWhereClause & " AND C_CustomerGroupID=" & CG_ID
	strPageTitle = " - " & GetString("PageTitle_CustomerGroups")
End If

If blnApprovedOnly then
	strWhereClause = strWhereClause & "  AND C_AffiliateCommission = 0 AND C_IsAffiliate = 'y'"
	strPageTitle = " - " & GetString("PageTitle_Affiliates")
End If
	
If blnAffiliatesOnly then
	strWhereClause = strWhereClause & " AND C_IsAffiliate = 'y'"
	strPageTitle = " - " & GetString("PageTitle_Affiliates")
End If

If blnMailingListOnly then
	strWhereClause = strWhereClause & " AND C_ML_SendMail = 'y'"
	strPageTitle = " - " & GetString("PageTitle_MailingList")
End If
	
If strSearchText <> "" then
	C_ID = NumSafe(strSearchText)
	If C_ID > 0 then
		strWhereClause = strWhereClause & " AND C_ID=" & C_ID
	Else
		strWhereClause = strWhereClause & " AND (" & GetLikeStatement(Split("C_EmailAddress,C_CardholderName,C_CardholderCompany,C_CardholderEUVATNum,C_CardholderStreetAddress,C_CardholderTownCity,C_CardholderCounty,C_CardholderPostCode,C_CardholderCountry", ","), strSearchText) & ")"
	End If
Else
	strWhereClause = strWhereClause & " AND C_EmailAddress <> ''"
end if

strQuery = "SELECT * FROM tblCactuShop" & TABLE_PREFIX & "Customers WHERE " & strWhereClause & " ORDER BY C_ID DESC"
Call ExecuteRS(strQuery, objRecordSet)
numRecordCount = objRecordSet.recordcount

'If we've found one record and we searched by ID, redirect straight to that customer
If numRecordCount = 1 and C_ID > 0 then
	objRecordSet.Close
	Call EndPage()
	response.Redirect("_modify_customerstatus.asp?" & strSessionQS & "C_ID=" & C_ID)
End If

'Move on to the right start record
If numStartRecord > 1 then
	objRecordSet.Move numStartRecord - 1
End If

numRecordsToDo = Min(PAGE_SIZE, numRecordCount - numStartRecord + 1)

%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
	<head>
		<link rel="Bookmark" href="favicon.ico" />
		<link rel="SHORTCUT ICON" href="favicon.ico" />
		<link href="includes/backend.css" rel="stylesheet" title="cactusoft" type="text/css" />
		<link href="includes/adminbar.css" rel="stylesheet" title="cactusoft" type="text/css" />
		<meta name="GENERATOR" content="www.cactusoft.com" />
		<!--
		===============================================================================
		CACTUSHOP v6.1 ASP SHOPPING CART
		1999-2007 CACTUSOFT INTERNATIONAL FZ-LLC. - WWW.CACTUSHOP.COM
		All rights reserved.
		===============================================================================
		-->
		<title><% =GetString("Config_headtitle") %></title>
	</head>
<body bgcolor="#FFFFFF" LEFTMARGIN="0" TOPMARGIN="0" MARGINWIDTH="0" MARGINHEIGHT="0">

<table border="0" cellpadding="0" cellspacing="0" width="100%">
	<tr>
		<td colspan="2"><!--#include file="includes/back_header.asp"--></td>
	</tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="660">
	<tr>
		<td valign="top" width="190"><!--#include file="includes/back_menu.asp"--></td>
		<td valign="top">
			<form action="_customers_list.asp" method="get" id="frmListCustomers">
			<input type="hidden" name="CG_ID" value="<%= CG_ID %>" />
			<input type="hidden" name="strApprove" value="<%= IIf(blnApprovedOnly, "y", "") %>" />
			<input type="hidden" name="strAffiliates" value="<%= IIf(blnAffiliatesOnly, "y", "") %>" />
			<%= objCactuSession.Form %>
				<table border="0" cellpadding="5" cellspacing="0" width="100%">
					<tr>
						<td><h1><%= GetString("PageTitle_Customers") & strPageTitle %></h1></td>
					</tr>
					<tr>
						<td><span><% WriteString("ContentText_FindACustomer") %></span> <input type="text" name="strSearchText" value="<%= WriteSafe(strSearchText) %>" /> <input type="submit" name="btnSubmit" value="<% WriteString("FormButton_Search") %>" /></td>
					</tr>
					<tr>
						<td class="small"><% WriteString("ContentText_EnterEmailAddress") %></td>
					</tr>
				</table>
			</form><%
			
			if numRecordCount = 0 then %>
				<table border="0" cellpadding="5" cellspacing="0" width="100%" ID="Table1">
					<tr>
						<td><br /><% WriteString("ContentText_NoCustomersWereFound") %><br /><br /></td>
					</tr>
				</table><%
			Else %>
			
				<table border="0" cellpadding="5" cellspacing="0" width="100%">
					<tr>
						<td>
							<table border="0" cellpadding="3" cellspacing="0" width="450">
								<tr>
									<td class="small bold dull" width="25%"><% WriteString("ContentText_CustomerName") %></td>
									<td class="small bold dull" width="45%"><% WriteString("ContentText_Email") %></td>
									<td class="small bold dull" width="30%">&nbsp;</td>
								</tr>
								<%
								If strAppAffiliateCommissionOnlyOnPaid = "y" then strSQLPaid = " AND tblCactuShop" & TABLE_PREFIX & "Orders.O_Paid = 'y'"
									
								Do While numCustomerCount < numRecordsToDo
									numCustomerCount = numCustomerCount + 1
									
									'Set background colours
									If numCustomerCount mod 2 = 0 then
										strThisBgColour="#EEEEEE"
										strBgColourWarn="#FFAAAA"
										strBgColourFine="#99CC99"
										strBgColourNotActiv="#99B0DB"
									else
										strThisBgColour="#DDDDDD"
										strBgColourWarn="#FFBBBB"
										strBgColourFine="#99DD99"
										strBgColourNotActiv="#99B0DB"
									end if

									'If we're doing affiliates, set background based on whether they're owed
									If blnApprovedOnly or blnAffiliatesOnly then
										numTotalCommission = ExecuteScalar("SELECT SUM(ROUND(O_AffiliateTotalPrice * (O_AffiliatePercentage/100) + 0.0000001, 2)) AS TotalCommission FROM tblCactuShop" & TABLE_PREFIX & "Orders INNER JOIN tblCactuShop" & TABLE_PREFIX & "Customers ON tblCactuShop" & TABLE_PREFIX & "Orders.O_CustomerID = tblCactuShop" & TABLE_PREFIX & "Customers.C_ID WHERE tblCactuShop" & TABLE_PREFIX & "Customers.C_AffiliateID = " & objRecordSet("C_ID") & " AND tblCactuShop" & TABLE_PREFIX & "Orders.O_AffiliatePaymentID = 0 AND tblCactuShop" & TABLE_PREFIX & "Orders.O_Sent = 'y' AND C_EmailAddress <> ''" & strSQLPaid)
										numTotalOldCommission = ExecuteScalar("SELECT SUM(ROUND(O_AffiliateTotalPrice * (O_AffiliatePercentage/100) + 0.0000001, 2)) AS TotalOldCommission FROM tblCactuShop" & TABLE_PREFIX & "Orders INNER JOIN tblCactuShop" & TABLE_PREFIX & "Customers ON tblCactuShop" & TABLE_PREFIX & "Orders.O_CustomerID = tblCactuShop" & TABLE_PREFIX & "Customers.C_ID WHERE tblCactuShop" & TABLE_PREFIX & "Customers.C_AffiliateID = " & objRecordSet("C_ID") & " AND tblCactuShop" & TABLE_PREFIX & "Orders.O_AffiliatePaymentID = 0 AND tblCactuShop" & TABLE_PREFIX & "Orders.O_Sent = 'y' AND C_EmailAddress <> '' AND O_Date <= " & strDateDelimiter & ReverseDate(datOldOrder) & strDateDelimiter & strSQLPaid)
										If numTotalCommission = 0 then strThisBgColour = strBgColourFine
										If numTotalOldCommission > 0 then strThisBgColour = strBgColourWarn
										If objRecordSet("C_IsAffiliate") <> "y" or objRecordSet("C_AffiliateCommission") = 0 then strThisBgColour = strBgColourNotActiv
									End if %>
									<tr bgcolor="<%= strThisBgColour %>">
										<td class="small"><%= WriteSafe(objRecordSet("C_CardholderName")) %></td>
										<td class="small"><a href="mailto:<%= WriteSafe(objRecordSet("C_EmailAddress")) %>"><%= WriteSafe(objRecordSet("C_EmailAddress")) %></a></td>
										<td class="small" align="right"><% If objRecordSet("C_IsAffiliate") = "y" AND objRecordSet("C_AffiliateCommission") > 0 then %>
											<a href="_affiliate_payrep.asp?<%= objCactuSession.QS %>C_ID=<% =objRecordSet("C_ID") %>"><img alt="<% WriteSafeString("ImageLabel_PayThisAffiliate") %>" title="<% WriteSafeString("ImageLabel_PayThisAffiliate") %>" src="images/b_payment.gif" border="0" /></a>
										<% End if %>
										<a href="_orders_list.asp?<%= objCactuSession.QS %>C_EmailAddress=<%= URLSafe(objRecordSet("C_EmailAddress")) %>"><img src="images/b_order.gif" border="0" alt="<% WriteSafeString("ContentText_ListOrders") %>" title="<% WriteSafeString("ContentText_ListOrders") %>" /></a>&nbsp;<a href="_modify_customerstatus.asp?<%= objCactuSession.QS %>C_ID=<% =objRecordSet("C_ID") %>"><img src="images/b_customer.gif" border="0" alt="<% WriteSafeString("ImageLabel_ViewThisCustomer") %>" title="<% WriteSafeString("ImageLabel_ViewThisCustomer") %>" /></a></td>
									</tr>		
									<% objRecordSet.MoveNext
								loop
								objRecordSet.Close %>
							</table>
						</td>
					</tr>
					
					<!-- Paging -->
					<tr>
						<td class="paging"><%
							'Build up querystring
							strQS = objCactuSession.QS & "strSearchText=" & URLSafe(strSearchText) & "&amp;CG_ID=" & CG_ID & IIf(blnApprovedOnly, "&amp;strApprove=y", "") & IIf(blnAffiliatesOnly AND instr(objCactuSession.QS,"strAffiliates") = -1, "&amp;strAffiliates=y", "") & "&amp;"
							
							'Work out the first and last page we're link to
							numCurrentPage = (numStartRecord - 1 + PAGE_SIZE) / PAGE_SIZE
							numTotalPages = numRecordCount \ PAGE_SIZE + IIf(numRecordCount mod PAGE_SIZE = 0, 0, 1)
							
							numFirstPage = MAX(numCurrentPage - (MAX_PAGES / 2), 1)
							numLastPage = MIN(numFirstPage + MAX_PAGES - 1, numTotalPages)
							If numLastPage = numTotalPages then numFirstPage = numLastPage - MAX_PAGES + 1
														
							'Previous link
							If numStartRecord > 1 then
								response.Write "<a href=""?" & strQS & "numStartRecord=" & numStartRecord - PAGE_SIZE & strSelectedFilter & """>&#171; " &  GetString("ContentText_Previous") & "</a> "
							Else 
								response.Write "&#171; " & GetString("ContentText_Previous") & " "
							End If
							
							'Display link for each page
							For i = 1 to numRecordCount Step PAGE_SIZE 
								numPage = (i - 1 + PAGE_SIZE) / PAGE_SIZE 
								If numPage < numFirstPage then 
									If not blnDoneFirstPageEllipsis then
										response.Write "... "
										blnDoneFirstPageEllipsis = true
									End If
								ElseIf numPage > numLastPage then
									If not blnDoneLastPageEllipsis then
										response.Write "... "
										blnDoneLastPageEllipsis = true
									End If
								Else	
									If i = numStartRecord Then
										response.Write " " & numPage & " "
									Else
										response.Write "<a href=""?" & strQS & "numStartRecord=" & i & strSelectedFilter & """>" & numPage & "</a> "
									End If
								End If
							Next 
							If numStartRecord + numRecordsToDo - 1 < numRecordCount then
								response.Write "<a href=""?" & strQS & "numStartRecord=" & numStartRecord + PAGE_SIZE & strSelectedFilter & """>" &  GetString("ContentText_Next") & " &#187;</a> "
							Else 
								response.Write GetString("ContentText_Next") & " &#187; "
							End If%>
						</td>
					</tr>
				</table><%
			End If %>
		</td>
	</tr>
</table>
</body>
</html>
<%
Call EndPage()
%>
