<%@ LANGUAGE="VBSCRIPT" %>
<% PageStrings = "55, 304, 339, 361, 470, 496, 503, 508, 634, 635, 641, 642, 653, 665, 666, 680, 825, 837, 1012, 1186, 1743"
blnDateStrings = true
strThisBackPage = "orders" %>
<!--#include file="includes/config.asp"-->
<!--#include file="includes/functions.asp"-->
<!--#include file="includes/back_security.asp"-->
<%
'===============================================
' CactuShop ASP Shopping Cart
' 1999-2007 Cactusoft International FZ-LLC
' www.cactusoft.com
'===============================================
' All rights reserved.							
' Use of this code is covered by the terms and	
' conditions in the license agreement. No		
' unauthorized duplication or distribution is	
' permitted. Cactusoft's copyright notices must	
' remain in the ASP sections of the code.		
'===============================================

'-----------------------------------------------
'CREATE INVOICE
'-----------------------------------------------
numOrderID = NumSafe(request.Querystring("O_ID"))
numLangID = NumSafe(request.Querystring("LANG_ID"))

'-----------------------------------------------
'LOOKUP LANGUAGE AND ITS INVOICE TEMPLATE FILE
'-----------------------------------------------
strQuery = "SELECT * FROM tblCactuShop" & TABLE_PREFIX & "Languages WHERE LANG_ID = " & numLangID
Call ExecuteRS(strQuery, objRecordSet)
strPathToInvoice = server.mappath(objRecordSet("LANG_SkinLocation") & "invoice.htm")

Set objFileSystem = CreateObject("Scripting.FileSystemObject")

'Now we know where to look for skin, check it exists
If objFileSystem.FileExists(strPathToInvoice) then
	'read file and store as string
	Set objFile = objFileSystem.GetFile(strPathToInvoice)
	Set objTextStream = objFile.OpenAsTextStream(1,0)
	strPageBaseText = objTextStream.ReadAll
	set objTextStream = nothing
	set objFile = nothing
Else
	'no template found - display error and stop
	response.write("No invoice.htm template found at " & strPathToInvoice & "<br /><br />" & vbcrlf)
	response.end
End if

set objFileSystem = nothing
objRecordSet.close


'-----------------------------------------------
'LOOKUP THIS ORDER RECORD
'-----------------------------------------------
Set objOrderCurrency = New CurrencyData
strQuery = "SELECT * FROM (((tblCactuShop" & TABLE_PREFIX & "InvoiceRows INNER JOIN tblCactuShop" & TABLE_PREFIX & "Orders ON tblCactuShop" & TABLE_PREFIX & "InvoiceRows.IR_OrderNumberID = tblCactuShop" & TABLE_PREFIX & "Orders.O_ID) INNER JOIN tblCactuShop" & TABLE_PREFIX & "Currencies ON tblCactuShop" & TABLE_PREFIX & "Currencies.CUR_ID = tblCactuShop" & TABLE_PREFIX & "Orders.O_CurrencyID) INNER JOIN tblCactuShop" & TABLE_PREFIX & "Customers ON tblCactuShop" & TABLE_PREFIX & "Orders.O_CustomerID = tblCactuShop" & TABLE_PREFIX & "Customers.C_ID) INNER JOIN tblCactuShop" & TABLE_PREFIX & "Languages ON tblCactuShop" & TABLE_PREFIX & "Orders.O_LanguageID = tblCactuShop" & TABLE_PREFIX & "Languages.LANG_ID WHERE O_ID = " & numOrderID
Call ExecuteRS(strQuery, objRecordSet)
'Set the database record count
numRecordCount = objRecordSet.recordcount

	If numRecordCount>0 then
		C_ID = objRecordSet("C_ID")
		C_CardholderEUVATNum = WriteSafe(objRecordSet("C_CardholderEUVATNum"))

		'We pull out billing and shipping addresses from
		'the orders table rather than use the ones in
		'the customer table - this way we get the ones
		'that applied to this actual order. Otherwise
		'we would show the latest details which *might*
		'be newer (and hence different).

		O_BillingAddress = objRecordSet("O_BillingAddress")
		O_ShippingAddress = objRecordSet("O_ShippingAddress")


		If O_BillingAddress = "" then
			O_BillingAddress = O_BillingAddress & objRecordSet("C_CardholderName") & vbcrlf
			O_BillingAddress = O_BillingAddress & objRecordSet("C_CardholderCompany") & vbcrlf
			O_BillingAddress = O_BillingAddress & objRecordSet("C_CardholderStreetAddress") & vbcrlf
			O_BillingAddress = O_BillingAddress & objRecordSet("C_CardholderTownCity") & vbcrlf
			O_BillingAddress = O_BillingAddress & objRecordSet("C_CardholderCounty") & vbcrlf
			O_BillingAddress = O_BillingAddress & objRecordSet("C_CardholderPostCode") & vbcrlf
			O_BillingAddress = O_BillingAddress & GetCountryString(objRecordSet("C_CardholderCountry"), 1)

			O_BillingAddress = replace(O_BillingAddress, vbcrlf & vbcrlf, vbcrlf)
		End if

		If O_ShippingAddress = "" then

			O_ShippingAddress = O_ShippingAddress & objRecordSet("C_ShippingName") & vbcrlf
			O_ShippingAddress = O_ShippingAddress & objRecordSet("C_ShippingStreetAddress") & vbcrlf
			O_ShippingAddress = O_ShippingAddress & objRecordSet("C_ShippingTownCity") & vbcrlf
			O_ShippingAddress = O_ShippingAddress & objRecordSet("C_ShippingCounty") & vbcrlf
			O_ShippingAddress = O_ShippingAddress & objRecordSet("C_ShippingPostCode") & vbcrlf
			O_ShippingAddress = O_ShippingAddress & GetCountryString(objRecordSet("C_ShippingCountry"), 1)

			O_ShippingAddress = replace(O_ShippingAddress, vbcrlf & vbcrlf, vbcrlf)
		End if

		If O_ShippingAddress = "" then O_ShippingAddress = O_BillingAddress

		O_PromotionDescription = objRecordSet("O_PromotionDescription")
		O_ShippingMethod = objRecordSet("O_ShippingMethod")
		O_TotalPrice = objRecordSet("O_TotalPrice")
		O_TotalPriceGateway = objRecordSet("O_TotalPriceGateway")
		O_CurrencyIDGateway = objRecordSet("O_CurrencyIDGateway")
		O_Date = objRecordSet("O_Date")
		O_PurchaseOrderNo = objRecordSet("O_PurchaseOrderNo")
		O_Status = objRecordSet("O_Status")
		O_LastModified = objRecordSet("O_LastModified")
		O_Sent = objRecordSet("O_Sent")
		O_Invoiced = objRecordSet("O_Invoiced")
		O_Shipped = objRecordSet("O_Shipped")
		O_Paid = objRecordSet("O_Paid")
		O_CouponCode = objRecordSet("O_CouponCode")
		O_CouponDiscountTotal = objRecordSet("O_CouponDiscountTotal")
		O_PromotionDiscountTotal = objRecordSet("O_PromotionDiscountTotal")
		O_PricesIncTax = objRecordSet("O_PricesIncTax")
		O_TaxDue = objRecordSet("O_TaxDue")
		O_LanguageID = objRecordSet("O_LanguageID")

		numShippingPriceExTax = objRecordSet("O_ShippingPrice")
		numShippingPriceIncTax = objRecordSet("O_ShippingPrice") + objRecordSet("O_ShippingTax")
		numShippingTaxTotal = objRecordSet("O_ShippingTax")

		numOrderHandlingPriceExTax = objRecordSet("O_OrderHandlingCharge")
		numOrderHandlingPriceIncTax = numOrderHandlingPriceExTax + objRecordSet("O_OrderHandlingChargeTax")
		numOrderHandlingTaxTotal = objRecordSet("O_OrderHandlingChargeTax")

		numTotal = objRecordSet("O_TotalPrice")
		numDiscountPercentage = objRecordSet("O_DiscountPercentage")

		objOrderCurrency.Load(objRecordSet)
		
		C_ID = objRecordSet("C_ID")
	End if
	
	'-----------------------------------------------
	'LOOKUP COUPON IF THERE IS ONE
	'-----------------------------------------------
	If O_CouponCode<>"" then
		strQuery2 = "SELECT * FROM tblCactuShop" & TABLE_PREFIX & "Coupons WHERE CP_CouponCode='" & SQLSafe(O_CouponCode) & "'"
		Call ExecuteRS(strQuery2, objRecordSet2)

		CP_DiscountValue = -objRecordSet2("CP_DiscountValue")
		CP_DiscountType = objRecordSet2("CP_DiscountType")
		If CP_DiscountType = "f" then CP_DiscountValue = O_CouponDiscountTotal
		CP_CouponCode = objRecordSet2("CP_CouponCode")
		objRecordSet2.close
	End if

'-----------------------------------------------
'REPLACE TAGS WITH VALUES
'-----------------------------------------------
strTemplateStyleFolder = strTemplateShopFolder & strLanguageSkinLocation & "templatestyles/"
strTemplateImagesFolder = strTemplateShopFolder & strLanguageSkinLocation & "templateimages/"
strBillingAddress = replace(O_BillingAddress & "", vbcrlf, "<br />" & vbcrlf)
strShippingAddress = replace(O_ShippingAddress & "", vbcrlf, "<br />" & vbcrlf)

strPageBaseText = replace(strPageBaseText, "templatestyles", strTemplateStyleFolder)
strPageBaseText = replace(strPageBaseText, "templateimages", strTemplateImagesFolder)
strPageBaseText = replace(strPageBaseText, "shopfolder/", strTemplateShopFolder)
strPageBaseText = replace(strPageBaseText, "xxxBILLINGxxx", strBillingAddress)
strPageBaseText = replace(strPageBaseText, "xxxSHIPPINGxxx", strShippingAddress)
strPageBaseText = replace(strPageBaseText, "xxxO_IDxxx", numOrderID)
strPageBaseText = replace(strPageBaseText, "xxxPOxxx", O_PurchaseOrderNo)
strPageBaseText = replace(strPageBaseText, "xxxC_IDxxx", C_ID)
strPageBaseText = replace(strPageBaseText, "xxxDATExxx", FormatDate(O_Date, strDateFormat))
strPageBaseText = replace(strPageBaseText, "xxxVATNUMxxx", C_CardholderEUVATNum)

aryTemplate = split(strPageBaseText, "xxxINVOICEROWSxxx", -1)

response.write(aryTemplate(0)) %>

<table id="invoiceitems">
<tr>
	<th></th>
	<th><% WriteString("ContentText_ExTax") %>&nbsp;</th>
	<th><% WriteString("ContentText_Qty") %></th>	
	<th><% WriteString("ContentText_Total") %></th>
	<th><% WriteString("ContentText_Tax") %>&nbsp;</th>
	<th><% WriteString("ContentText_Total") %></th>
</tr>
<%
'-----------------------------------------
'CREATE INVOICE ROWS
'-----------------------------------------
do while NOT objRecordSet.EOF %>
	<tr> 
		<td colspan="6" class="fullline"><% =objRecordSet("IR_VersionName") %></td>
	</tr>
	<tr> 
		<td class="col1">
		<% 
		response.Write objRecordSet("IR_VersionCode")
		IR_OptionsText = objRecordSet("IR_OptionsText") & ""
		If IR_OptionsText <> "" then response.Write "<br />" & Replace(IR_OptionsText, vbcrlf, "<br />")
		%>		
		</td>		
		
<%
'-----------------------------------------------
'CALCULATE ITEM & ROW TOTALS
'-----------------------------------------------
If O_PricesIncTax = "y" then
	'PRICES INCLUDING TAX
	numItemPriceExTax = objRecordSet("IR_PricePerItem") - objRecordSet("IR_TaxPerItem")
	numItemPriceIncTax = objRecordSet("IR_PricePerItem")
	numRowPriceExTax = Round((objRecordSet("IR_Quantity") * numItemPriceExTax) - 0.0001, 2)
	numRowPriceIncTax = objRecordSet("IR_PricePerItem") * objRecordSet("IR_Quantity")
Else
	'PRICES EXCLUDING TAX
	numItemPriceExTax = objRecordSet("IR_PricePerItem")
	numRowPriceExTax = Round(objRecordSet("IR_PricePerItem") * objRecordSet("IR_Quantity") , 2)
	numRowPriceIncTax = Round(objRecordSet("IR_PricePerItem") * objRecordSet("IR_Quantity") * (1 + objRecordSet("IR_TaxPerItem")) + 0.0001, 2)
End if

'-----------------------------------------------
'CALCULATE INVOICE TOTALS
'The total amount without tax is not stored - 
'this is calculated from the invoice rows
'records as we cycle through them.
'-----------------------------------------------
numTotalPriceExTax = numTotalPriceExTax + numRowPriceExTax
numTotalPriceIncTax = numTotalPriceIncTax + numRowPriceIncTax
numRowTaxAmount = Round(numRowPriceIncTax - numRowPriceExTax, 2)
numTotalTaxAmount = numTotalTaxAmount + numRowTaxAmount

		%>
		<td><% =CUR_Symbol & " " & objOrderCurrency.Display(numItemPriceExTax, false, false) %></td>
		<td><% =objRecordSet("IR_Quantity") %></td>
		<td><% =objOrderCurrency.Display(numRowPriceExTax, false, false) %></td>
		<td><% =objOrderCurrency.Display(numRowTaxAmount, false, false) %></td>
		<td class="bold"><% =objOrderCurrency.Display(numRowPriceIncTax, false, false) %></td>
	</tr>
<%
objRecordSet.movenext
loop

'-----------------------------------------------
'CALCULATE PROMOTION TOTAL
'Need to back track from values available in
'the orders table record.
'-----------------------------------------------
If O_PromotionDiscountTotal <> 0 then
	If numTotalPriceExTax = 0 then
		numTotalTaxFraction = 0
	else
		numTotalTaxFraction = numTotalTaxAmount  / numTotalPriceExTax
	End if

	numPromotionDiscountIncTax = Round(O_PromotionDiscountTotal, 2)
	numPromotionDiscountExTax = numPromotionDiscountIncTax * (1 - (numTotalTaxFraction / (1 + numTotalTaxFraction)))
	numPromotionDiscountTaxAmount = numPromotionDiscountIncTax - numPromotionDiscountExTax

End if

'-----------------------------------------------
'CALCULATE COUPON TOTAL
'Need to back track from values available in
'the orders table record.
'-----------------------------------------------
If O_CouponCode <> "" then
	If numTotalPriceExTax = 0 then
		numTotalTaxFraction = 0
	else
		numTotalTaxFraction = numTotalTaxAmount  / numTotalPriceExTax
	End if
	If CP_DiscountType = "p" then 'PERCENTAGE
		numCouponDiscountIncTax = Round((CP_DiscountValue * numTotalPriceIncTax / 100), 2)
		numCouponDiscountExTax = Round((CP_DiscountValue * numTotalPriceExTax / 100), 2)
		numCouponDiscountTaxAmount = numCouponDiscountIncTax - numCouponDiscountExTax
	elseif CP_DiscountType = "f" then
		numCouponDiscountIncTax = Round(CP_DiscountValue, 2)
		numCouponDiscountExTax = numCouponDiscountIncTax * (1 - (numTotalTaxFraction / (1 + numTotalTaxFraction)))
		numCouponDiscountTaxAmount = numCouponDiscountIncTax - numCouponDiscountExTax
	else
		numCouponDiscountIncTax = 0
		numCouponDiscountExTax = 0
		numCouponDiscountTaxAmount = 0
	end if
End if

'-----------------------------------------------
'CALCULATE CUSTOMER DISCOUNT TOTAL
'Need to back track from values available in
'the ordernumbers table record.
'-----------------------------------------------
If numDiscountPercentage <> 0 then

	numCustomerDiscountExTax = -Round((((numTotalPriceExTax + numCouponDiscountExTax) * (numDiscountPercentage / 100))), 2)
	numCustomerDiscountIncTax = -Round(((numTotalPriceIncTax + numCouponDiscountIncTax) * (numDiscountPercentage / 100)), 2)
	numCustomerDiscountTaxAmount = numCustomerDiscountIncTax - numCustomerDiscountExTax

	strDiscountPercentage = GetString("ContentText_Discount") & " = " & numDiscountPercentage & "%<br />"
End if

'-----------------------------------------------
'SET TOTAL AND TAX VALUES
'Depends whether order includes tax or not.
'-----------------------------------------------
If O_TaxDue=1 then
	numOrderValueTotal = numTotalPriceIncTax
	numCouponDiscountValue = numCouponDiscountIncTax
	numCustomerDiscountValue = numCustomerDiscountIncTax
	numShippingPrice = numShippingPriceIncTax
	numOrderHandlingPrice = numOrderHandlingPriceIncTax	
Else
	numOrderValueTotal = numTotalPriceExTax
	numCouponDiscountValue = numCouponDiscountExTax
	numCustomerDiscountValue = numCustomerDiscountExTax
	numShippingPrice = numShippingPriceExTax
	numOrderHandlingPrice = numOrderHandlingPriceExTax
End if
		
'-----------------------------------------
'DEAL WITH LEGACY ISSUES
'Before v5.117, there was a tag for the
'totals which were formed as a string
'and then replaced, like the other tags.
'In v5.117, the invoice generation was
'given a facelift and this was changed.
'Because many invoice skins, including
'the one in our demo, might still have
'the defunct xxxTOTALSxxx tag in, we just
'blank it here so it doesn't mess things
'up. In years to come, invoice templates
'won't have this tag and we'll probably
'remove this bit of code.
'-----------------------------------------
aryTemplate(1) = replace(aryTemplate(1), "xxxTOTALSxxx", "")


'-----------------------------------------
'PROMOTION
'-----------------------------------------
If O_PromotionDiscountTotal <> 0 then
%>
	<tr> 
		<td colspan="6" class="fullline section"><% =GetString("ContentText_PromotionDiscount") %></td>
	</tr>
	<tr> 
		<td class="col1"><%= Replace(O_PromotionDescription, vbcrlf, "<br />") %></td>
		<td><% =objOrderCurrency.Display(numPromotionDiscountExTax, false, false) %></td>
		<td>1</td>
		<td><% =objOrderCurrency.Display(numPromotionDiscountExTax, false, false) %></td>
		<td><% =objOrderCurrency.Display(numPromotionDiscountTaxAmount, false, false) %></td>
		<td class="bold"><% =objOrderCurrency.Display(O_PromotionDiscountTotal, false, false) %></td>
	</tr>
<%
End if
'-----------------------------------------
'/PROMOTION DISCOUNT
'-----------------------------------------

'-----------------------------------------
'COUPON
'-----------------------------------------
If numCouponDiscountValue <> 0 then
%>
	<tr> 
		<td colspan="6" class="fullline section"><% WriteString("ContentText_CouponDiscount") %></td>
	</tr>
	<tr> 
		<td class="col1"><% =CP_CouponCode %></td>
		<td><% =objOrderCurrency.Display(numCouponDiscountExTax, false, false) %></td>
		<td>1</td>
		<td><% =objOrderCurrency.Display(numCouponDiscountExTax, false, false) %></td>
		<td><% =objOrderCurrency.Display(numCouponDiscountTaxAmount, false, false) %></td>
		<td class="bold"><% =objOrderCurrency.Display(numCouponDiscountValue, false, false) %></td>
	</tr>
<%
End if
'-----------------------------------------
'/COUPON
'-----------------------------------------

'-----------------------------------------
'CUSTOMER DISCOUNT
'-----------------------------------------
If numCustomerDiscountValue <> 0 then
%>
	<tr> 
		<td colspan="6" class="fullline section"><% =GetString("ContentText_Discount") %></td>
	</tr>
	<tr> 
		<td class="col1"><% =numDiscountPercentage %>%</td>
		<td><% =objOrderCurrency.Display(numCustomerDiscountExTax, false, false) %></td>
		<td>1</td>
		<td><% =objOrderCurrency.Display(numCustomerDiscountExTax, false, false) %></td>
		<td><% =objOrderCurrency.Display(numCustomerDiscountTaxAmount, false, false) %></td>
		<td class="bold"><% =objOrderCurrency.Display(numCustomerDiscountValue, false, false) %></td>
	</tr>
<%
End if
'-----------------------------------------
'/CUSTOMER DISCOUNT
'-----------------------------------------

'-----------------------------------------
'SHIPPING COST
'-----------------------------------------
If numShippingPrice <> 0 then
%>
	<tr> 
		<td colspan="6" class="fullline section"><% WriteString("ContentText_Shipping") %></td>
	</tr>
	<tr> 
		<td class="col1"><% =O_ShippingMethod %></td>
		<td><% =objOrderCurrency.Display(numShippingPriceExTax, false, false) %></td>
		<td>1</td>
		<td><% =objOrderCurrency.Display(numShippingPriceExTax, false, false) %></td>
		<td><% =objOrderCurrency.Display(numShippingTaxTotal, false, false) %></td>
		<td class="bold"><% =objOrderCurrency.Display(numShippingPrice, false, false) %></td>
	</tr>
<%
End if
'-----------------------------------------
'/SHIPPING COST
'-----------------------------------------

'-----------------------------------------
'ORDER HANDLING CHARGE
'-----------------------------------------
If numOrderHandlingPrice <> 0 then
%>
	<tr> 
		<td colspan="6" class="fullline section"><% WriteString("ContentText_OrderHandlingCharge") %></td>
	</tr>
	<tr>
		<td class="col1"></td>
		<td><% =objOrderCurrency.Display(numOrderHandlingPriceExTax, false, false) %></td>
		<td>1</td>
		<td><% =objOrderCurrency.Display(numOrderHandlingPriceExTax, false, false) %></td>
		<td><% =objOrderCurrency.Display(numOrderHandlingTaxTotal, false, false) %></td>
		<td class="bold"><% =objOrderCurrency.Display(numOrderHandlingPrice, false, false) %></td>
	</tr>
<%
End if
'-----------------------------------------
'/ORDER HANDLING CHARGE
'-----------------------------------------

'-----------------------------------------
'TOTAL
'-----------------------------------------
numTotalTaxAmount = numTotalTaxAmount + numCouponDiscountTaxAmount + TaxAmount + numCustomerDiscountTaxAmount + numShippingTaxTotal + numOrderHandlingTaxTotal + numPromotionDiscountTaxAmount
numTotalExTax = numTotal - numTotalTaxAmount
%>
	<tr id="total"> 
		<td class="col1"><% =GetString("ContentText_Total") %></td>
		<td></td>
		<td></td>
		<td><% =objOrderCurrency.Display(numTotalExTax, false, false) %></td>
		<td><% =objOrderCurrency.Display(numTotalTaxAmount, false, false) %></td>
		<td><% =objOrderCurrency.Display(numTotal, false, false) %></td>
	</tr>
<%
'-----------------------------------------
'/TOTAL
'-----------------------------------------

'-----------------------------------------
'TOTAL IN GATEWAY CURRENCY
'-----------------------------------------
If O_TotalPriceGateway <> numTotal then

	'-----------------------------------------
	'LOOKUP GATEWAY CURRENCY USED
	'Only needed if different from the one the
	'customer used.
	'-----------------------------------------
	'Lookup details of currency gateway uses
	strQuery = "SELECT * FROM tblCactuShop" & TABLE_PREFIX & "Currencies WHERE CUR_ID = " & O_CurrencyIDGateway
	Call ExecuteRS(strQuery, objRecordSet2)
	Set objGatewayCurrency = New CurrencyData
	objGatewayCurrency.Load(objRecordSet2)
	objRecordSet2.close
	%>

	<tr id="processcurrency"> 
		<td colspan="6"><% =GetString("EmailText_ProcessCurrencyExp1") & "&nbsp;&nbsp;" & objGatewayCurrency.Display(O_TotalPriceGateway, false, false) %></td>
	</tr>
<%
End if
'-----------------------------------------
'/TOTAL  IN GATEWAY CURRENCY
'-----------------------------------------
%>
</table>
<% response.write(aryTemplate(1))

Call EndPage()
%>
