<%@ LANGUAGE="VBSCRIPT" %>
<% PageStrings = "400, 524, 525, 865, 1373, 1555, 1556, 1557, 1558"
strThisBackPage = "config" %>
<!--#include file="includes/config.asp"-->
<!--#include file="includes/functions.asp"-->
<!--#include file="includes/back_security.asp"-->
<%
'===============================================
' CactuShop ASP Shopping Cart
' 1999-2007 Cactusoft International FZ-LLC
' www.cactusoft.com
'===============================================
' All rights reserved.							
' Use of this code is covered by the terms and	
' conditions in the license agreement. No		
' unauthorized duplication or distribution is	
' permitted. Cactusoft's copyright notices must	
' remain in the ASP sections of the code.		
'===============================================

'-----------------------------------------------
'MODIFY SHIPPING METHOD						
'-----------------------------------------------

'-----------------------------------------------
'COLLECT VALUES FROM QUERYSTRING
'-----------------------------------------------
SM_ID = NumSafe(request.QueryString("SM_ID"))

'Arrays for info to go in
Dim SM_Name(), SM_Description()
Redim SM_Name(numTotalLanguages)
Redim SM_Description(numTotalLanguages)

'-----------------------------------------------
'PULL OUT THE SHIPPING METHOD INFO				
'-----------------------------------------------
If SM_ID > 0 then
	strQuery = "SELECT tblCactuShop" & TABLE_PREFIX & "ShippingMethods.* FROM tblCactuShop" & TABLE_PREFIX & "ShippingMethods WHERE SM_ID = " & SM_ID
	Call ExecuteRS(strQuery, objRecordSet)
	If not (objRecordSet.BOF and objRecordSet.EOF) then
		SM_ID = objRecordSet("SM_ID")
		SM_Live = objRecordSet("SM_Live")
		SM_OrderByValue = objRecordSet("SM_OrderByValue")
		
		'Loop through all languages and get the names and descriptions
		For numCount = 1 to numTotalLanguages	
			If aryLangLiveBack(numCount) = "y" then
				SM_Name(numCount) = objRecordSet("SM_Name" & CStr(numCount))
				SM_Description(numCount) = objRecordSet("SM_Description" & CStr(numCount))
				If SM_Name(numCount) <> "" then
					strFirstNonEmptyName = SM_Name(numCount)
				end if
			end if
		Next
		If SM_Name(numDefaultLanguage) <> "" then strFirstNonEmptyName = SM_Name(numDefaultLanguage)
	end if
	objRecordSet.Close
End If
SM_ID = NumSafe(SM_ID)
SM_Live = ListSafe(SM_Live, "y,n", "n")
SM_OrderByValue = NumSafe(SM_OrderByValue)

'Set page title
If strFirstNonEmptyName <> "" then
	strPageTitle = strFirstNonEmptyName
Else
	strPageTitle = GetString("PageTitle_AddNewShippingMethod")
End If
	
%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
	<head>
		<link rel="Bookmark" href="favicon.ico" />
		<link rel="SHORTCUT ICON" href="favicon.ico" />
		<link href="includes/backend.css" rel="stylesheet" title="cactusoft" type="text/css" />
		<link href="includes/adminbar.css" rel="stylesheet" title="cactusoft" type="text/css" />
		<meta name="GENERATOR" content="www.cactusoft.com" />
		<!--
		===============================================================================
		CACTUSHOP v6.1 ASP SHOPPING CART
		1999-2007 CACTUSOFT INTERNATIONAL FZ-LLC. - WWW.CACTUSHOP.COM
		All rights reserved.
		===============================================================================
		-->
		<title><% =GetString("Config_headtitle") %></title>
	</head>
<body bgcolor="#FFFFFF" LEFTMARGIN="0" TOPMARGIN="0" MARGINWIDTH="0" MARGINHEIGHT="0">
	<table border="0" cellpadding="0" cellspacing="0" width="100%">
		<tr>
			<td colspan="2"><!--#include file="includes/back_header.asp"--></td>
		</tr>
	</table>
	<table border="0" cellpadding="0" cellspacing="0" width="660">
		<tr>
			<td valign="top" width="190"><!--#include file="includes/back_menu.asp"--></td>
			<td valign="top">
				<form method="POST" name="verform" action="_update_shippingmethod.asp" id="frmUpdateShippingMethod">
					<%= objCactuSession.Form %>
					<input type="hidden" name="SM_ID" value="<% =SM_ID %>" />
					<table border="0" cellpadding="5" cellspacing="0" width="100%">
						<tr>
							<td><h1><%= strPageTitle %></h1></td>
						</tr>	
					</table>
					
					<table border="0" cellpadding="5" cellspacing="0" width="100%">
						<tr>
							<td><% WriteString("FormLabel_Live") %></td>
							<td><input<%= IIf(SM_Live = "y", " checked=""checked""", "") %> type="checkbox" name="SM_Live" value="y" /></td>
						</tr>
						
						<% For numCount = 1 to numTotalLanguages
							If aryLangLiveBack(numCount) = "y" then
								if numCount = 1 then %>
									<tr>
										<td colspan="2"><hr /></td>
									</tr>
								<% end if
								
								if numTotalLanguages > 1 then %>
									<tr>
										<td class="bold" colspan="2"><%= aryLangBackNames(numCount) %></td>
									</tr>
								<% end if %>
				
								<tr>
									<td><% WriteString("FormLabel_ShippingMethodName") %></td>
									<td><input type="text" name="SM_Name<% =numCount %>" value="<%= WriteSafe(SM_Name(numCount)) %>" size="28" /></td>
								</tr>
								<tr>
									<td valign="top"><% WriteString("FormLabel_ShippingMethodDesc") %></td>
									<td><textarea rows="5" name="SM_Description<% =numCount %>" cols="35" wrap="on"><%= WriteSafe(SM_Description(numCount)) %></textarea></td>
								</tr>
								<tr>
									<td colspan="2"><hr /></td>
								</tr>
							<% end if
						next %>
						
						<tr>
							<td valign="top"><% WriteString("FormLabel_OrderByValue") %></td>
							<td><input type="text" name="SM_OrderByValue" value="<% =SM_OrderByValue %>" size="5" /></td>
						</tr>

						<tr>
							<td>&nbsp;</td>
							<td align="right"><input type="submit" name="btnSubmit" id="submit" value="<%= IIf(SM_ID = 0, GetSafeString("FormButton_Add"), GetSafeString("FormButton_Update")) %>" /></td>
						</tr>
					</table>
				</form>

				<%
				'-----------------------------------------------
				'delete form
				'-----------------------------------------------
				If Not SM_ID = 0 Then %>
					<hr />
					<form method="POST" action="_update_shippingmethod.asp" id="frmDeleteShippingMethod">
						<%= objCactuSession.Form %>
						<input type="hidden" name="strCallMode" value="d" />
						<input type="hidden" name="SM_ID" value="<% =SM_ID %>" />
						<table border="0" cellpadding="5" cellspacing="0" width="100%">
							<tr bgcolor="#EEEEEE">
								<td align="right" width="70"><input type="submit" name="btnDelete" id="delete" value="<% WriteString("FormButton_Delete") %>" /></td>
								<td class="bold"><% WriteString("ContentText_DeleteThisShippingMethod") %></td>
							</tr>
						</table>
					</form>
				<% End If %>
			</td>
		</tr>
	</table>
</body>
</html>

<% 
Call EndPage()
%>
